<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Tree Nodes</TITLE>
<link href="suif1_12.html" rel=Next>
<link href="suif1_10.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_10.html">previous</A>, <A HREF="suif1_12.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC11" HREF="suif1_toc.html#TOC11">Tree Nodes</A></H2>
<P>
<A NAME="IDX24"></A>
<A NAME="IDX25"></A>

</P>
<P>
<A NAME="IDX26"></A>
The different kinds of AST nodes are represented by objects derived from
the <CODE>tree_node</CODE> class.  This base class includes features, such as
ID numbers, that are shared by all kinds of tree nodes.

</P>
<P>
The simplest kind of tree node is a <CODE>tree_instr</CODE>.  Each of these is
a leaf node that contains a single instruction or expression.

</P>
<P>
Conditional structures may be represented by <CODE>tree_if</CODE> nodes.

</P>
<P>
The ASTs include two different kinds of loop nodes.  The
<CODE>tree_loop</CODE> nodes just record the control-flow structure of the
loops and are used to represent generic "do-while" loops.  Many
optimizations, however, only apply to certain well-behaved types of
loops.  Thus, the trees may also contain <CODE>tree_for</CODE> nodes to
represent loops with scalar indices that vary from their initial to
final values, being incremented or decremented on every iteration, and
that meet various other requirements.  Most Fortran <CODE>DO</CODE> loops
qualify as <CODE>tree_for</CODE> nodes.  Those loops which do not meet the
requirements for <CODE>tree_for</CODE> nodes are represented by
<CODE>tree_loop</CODE> nodes instead.

</P>
<P>
Nested scopes are represented by <CODE>tree_block</CODE> nodes.  A
<CODE>tree_block</CODE> contains a list of tree nodes and a symbol table.  The
symbols and types in the table may only be referenced from within the
block.  The node at the root of an AST is a special kind of
<CODE>tree_block</CODE> called a <CODE>tree_proc</CODE>.  The <CODE>tree_proc</CODE>
objects use a slightly different kind of symbol table and include some
extra methods but are otherwise the same as the <CODE>tree_block</CODE>
objects.

</P>

<UL>
<LI><A HREF="suif1_12.html#SEC12">ID Numbers</A>: ID numbers for tree nodes and instructions.
<LI><A HREF="suif1_13.html#SEC13">Other Node Features</A>: Other features shared by all tree nodes.
<LI><A HREF="suif1_14.html#SEC14">Instruction Nodes</A>: Leaf nodes: instructions and expressions.
<LI><A HREF="suif1_15.html#SEC15">If Nodes</A>: Conditionals.
<LI><A HREF="suif1_16.html#SEC16">Loop Nodes</A>: General do-while loops.
<LI><A HREF="suif1_17.html#SEC17">For Nodes</A>: Nicely-structured FOR loops.
<LI><A HREF="suif1_18.html#SEC18">Block Nodes</A>: Nested scopes.
<LI><A HREF="suif1_19.html#SEC19">Procedure Nodes</A>: Root nodes for procedure bodies.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_10.html">previous</A>, <A HREF="suif1_12.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
